import random
import math
random.seed("basic01/alikingspress")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([1, 2, 3, 4], 14)
        self.print_test([1, 4, 2, 6, 3], 12)
        self.print_test([3, 4, 2], 8)

    def generate_min_tests(self):
        self.print_test([1], 1)
        self.print_test([2], 3)
        self.print_test([4], 100)
        self.print_test([1000], 1000000)
        self.print_test([1000], 999999)
        self.print_test([100], 99)
        self.print_test([2, 3], 6)
        self.print_test([3, 2], 101)
        self.print_test([2, 3, 7], 100)
        
    def generate_hand_tests(self):
        pass

    def generate_random_test(self, maxn, maxv, maxx):
        n = maxn
        a = []
        for i in range(n):
            a.append(random.randint(1, maxv))
        x = random.randint(1, maxx)
        self.print_test(a, x)

    def generate_max_tests(self, maxn, maxv, maxx):
        self.print_test([maxv] * maxn, maxx)
        self.print_test([1] * maxn, maxx)
        a = [i for i in range(1, maxn + 1)]
        self.print_test(a, maxx)
        self.print_test(a, maxx - random.randint(1, int(math.sqrt(maxx))))
        random.shuffle(a)
        self.print_test(a, maxx)
        self.print_test(a, maxx - random.randint(1, int(math.sqrt(maxx))))

    def print_test(self, a, x):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(len(a), x, file=test_file)
        print(' '.join(map(str, a)), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [10, 50, 100]
        maxvs = [5, 10, 100, 10**3]
        maxxs = [10, 100, 10**3, 10**6]
        for n in ns:
            for maxv in maxvs:
                for maxx in maxxs:
                    self.generate_random_test(n, maxv, maxx)
        self.generate_max_tests(10**2, 10**3, 10**6)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
